data	segment		page
	IO_8255a		equ	210h
	IO_8255b		equ	211h
	IO_8255c		equ	212h
	IO_8255k		equ	213h
	IO_8254		equ	220h
	IO_8259m0		equ	200h
	IO_8259m1		equ	201h
	IO_8259s0		equ	230h
	IO_8259s1		equ	231h
	portcl		db	81h,41h,01h,24h,22h,20h
	dig		db	3fh,06h,5bh,4fh,66h,6dh,7dh,07h,7fh,6fh
	num		db	5
data	ends

ssg	segment		stack	page
	dw	20h	dup(?)
ssg	ends

code	segment		page
	assume	cs:code,ds:data,ss:ssg
start:	mov	ax,data
	mov	ds,ax

	mov	dx,IO_8255k
	mov	al,10010000b
	out	dx,al							;8255ʼPAΪ룬PCΪ

	mov	dx,IO_8254
	add	dx,3		;ָƿ
	mov	al,00110111b	;0ʽ3
	out	dx,al		;BCD
	mov	dx,IO_8254	;ָT0
	mov	al,0		;ֵ
	out	dx,al
	out	dx,al		;ֵ10000
	mov	dx,IO_8254
	add	dx,3		;ָƿ
	mov	al,01010100b	;1ʽ2
	out	dx,al		
	mov	dx,IO_8254
	inc	dx
	mov	al,14h
	out	dx,al		;Ƽ200.2s			

	mov	dx,IO_8259m0	
	mov	al,11h
	out	dx,al				;ʼICW1 Ե+
	mov	dx,IO_8259m1
	mov	al,08h					
	out	dx,al				;ʼICW2
	mov	al,04h
	out	dx,al				;ʼICW3ir2ϽӴƬ
	mov	al,01h
	out	dx,al
	mov	al,0ffh
	out	dx,al				;ʱرƬж

	mov	dx,IO_8259s0
	mov	al,11h				
	out	dx,al				;ʼICW1 Ե+	
	mov	dx,IO_8259s1
	mov	al,76h	
	out	dx,al				;ʼICW2
	mov	al,02h
	out	dx,al				;ʼICW3ir2ϽӴƬ
	mov	al,01h
	out	dx,al
	mov	al,0ffh
	out	dx,al				;ʱرƬж

	push	ds
	mov	ax,0
	mov	ds,ax
	LEA	AX,CS:INT_08h
	mov	si,08h
	add	SI,si
	add	si,si
	mov	ds:[SI],AX
	PUSH	CS
	POP	AX
	MOV	ds:[SI+2],AX

	POP	DS			

	push	ds
	mov	ax,0
	mov	ds,ax
	
	LEA	AX,CS:INT_76h
	mov	si,76h
	add	SI,si
	add	si,si
	mov	ds:[SI],AX
	PUSH	CS
	POP	AX
	MOV	ds:[SI+2],AX
	POP	DS

	mov	dx,IO_8259m1		
	in 	al,dx
      	and 	al,11111010b    	;ƬIR5жϺһƬIR2
     	out 	dx,al  
	mov	dx,IO_8259s1		
	in 	al,dx
      	and 	al,10111111b    	;ŴƬIR0ж				޸8259
     	out 	dx,al  

	STI				;޸SIR070hж

	mov	cx,0
	mov	al,portcl
	mov	dx,IO_8255c
	out	dx,al
on:	mov	dx,IO_8255a
	in	al,dx
	test	al,01h
	jnz	on

	inc	cx
	cmp	cx,45
	jc	O1
	cmp	cx,55
	jc	O2
	cmp	cx,80
	jc	O3
	cmp	cx,90
	jc	O4
	mov	cx,0
O1:	mov	bx,0		;
	mov	si,8
	jmp	play
O2:	mov	bx,1		;߻Ƶ
	mov	si,10
	jmp	play2
O3:	mov	bx,3		;֧·
	mov	si,15
	jmp	play
O4:	mov	bx,4		;֧·Ƶ
	mov	si,17

play2:	test	cx,01h
	jz	play
	inc	bx
play:	mov	al,portcl[bx]
	mov	dx,IO_8255c
	out	dx,al
	mov	ax,cx
	div	num
	mov	ah,0
	sub	si,ax
	mov	al,dig[si]
	mov	dx,IO_8255b
	out	dx,al

L:	mov	dx,IO_8255a
	in	al,dx
	test	al,01h
	jnz	on
	jmp	L

INT_08h	proc	far
	push	ax
	push	dx
	push	cx
	push	di
	mov	cx,300
	de21:	mov	bx,1000
	de20:	dec	bx
	jnz	de20
	loop	de21
	mov	al,[portcl]
	mov	dx,IO_8255c
	out	dx,al
	mov	cx,1169
de11:	mov	di,1000
de01:	dec	di
	jnz	de02
	loop	de12

	MOV	AL,20H
	mov	dx,IO_8259m0
	OUT	dx,AL
	MOV	AL,20H
	mov	dx,IO_8259s0
	OUT	dx,AL
	pop	di
	pop	cx
	pop	dx
	pop	ax
	sti
	iret
INT_08h	endp

INT_76h	proc	far
	push	ax
	push	dx
	push	cx
	push	bx
	mov	cx,300
de1:	mov	bx,1000
de0:	dec	bx
	jnz	de0
	loop	de1

	mov	al,[portcl+3]
	mov	dx,IO_8255c
	out	dx,al
	mov	cx,1169
de12:	mov	bx,1000
de02:	dec	bx
	jnz	de02
	loop	de12

	MOV	AL,20H
	mov	dx,IO_8259m0
	OUT	dx,AL
	MOV	AL,20H
	mov	dx,IO_8259s0
	OUT	dx,AL
	pop	bx
	pop	cx
	pop	dx
	pop	ax
	sti
	iret
INT_76h	endp

code	ends
end	start
